local CDSpy = CreateFrame("Frame")
local addonName, addon = ...

--_G[addonName] = addon
addon.healthCheck = true

local eventFrame = CreateFrame("Frame", nil, InterfaceOptionsFramePanelContainer)
eventFrame:RegisterEvent("ADDON_LOADED")
eventFrame:RegisterEvent("PLAYER_LOGIN")
addon.frame = eventFrame

-- CastAnnounce
local cast              = "%s casts %s!"
local use               = "%s uses %s!"
local create_a          = "%s creates a %s!"
local create_an         = "%s creates an %s!"
local begin             = "%s begins a %s!"
local place             = "%s places a %s!"
local place_an          = "%s places an %s!"
local drink             = "%s drinks a %s!"
local drink_an          = "%s drinks an %s!"
local beat              = "%s beats %s!"
local use_on            = "%s uses %s on %s!"
local cast_on           = "%s casts %s on %s!"
local awaken            = "%s awakens %s!"
local decides_to        = "%s decides to %s!"
local ankh_avail        = "%s has died, %s is available!"
local ankh_used         = "%s uses %s and is back from the dead!"
local harness           = "%s harnesses %s!"

 
-- FadeAnnounce
local fade_from_target  = "%s's %s fades from %s!" -- healer-style
local fade              = "%s's %s fades!"          -- generic raid-wide style
local dies_horribly     = "%s dies. Horribly." -- Surrender to Madness special
 
 
-- CastCriteria
--SPELL_CAST_SUCCESS  -- most
--SPELL_AURA_APPLIED  -- rarer (almost none)
--SPELL_HEAL      -- Guardian Spirit / Ardent Defender
--SPELL_CREATE    -- portals / toys
--SPELL_CAST_START-- feasts
--SPELL_SUMMON    -- Lightwell
--SPELL_RESURRECT -- Rez
 
 
-- FadeCriteria
--SPELL_AURA_REMOVED  -- most/all
 
 
-- RoleCriteria
--tank -- marked as tank in raid frames
--healer -- has >X max mana
 
-- SPECIAL SPELLZ
--Reincarnate
--Pet Lust -- (need owner name, not pet name)
--Soulstone -- died with a stone, not cast on someone

local _, instance
local raid_channel_id, party_channel_id, pug_channel_id
local sacrifice, soulstones, reincarnations = {}, {}, {}
local raid_toggle, party_toggle, pug_toggle, taunt_toggle
local override

-- Upvalues
local UnitAffectingCombat, UnitName, UnitHealthMax, UnitManaMax, UnitExists = UnitAffectingCombat, UnitName, UnitHealthMax, UnitManaMax, UnitExists
local GetSpellLink, format, match = GetSpellLink, string.format, string.match

 
local SpellArray = {
 
 -- TAUNTS AND THREAT

   [56222] = {
--  Death Knight
--  Dark Command
    SpellID = "56222",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
    TankCriteria = true,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
    TauntAnnounce = true,
    
  },

  [6795] = {
--  Druid
--  Growl
    SpellID = "6795",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
    TankCriteria = true,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
    TauntAnnounce = true,
    
  },

  [115546] = {
--  Monk
--  Provoke
    SpellID = "115546",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
    TankCriteria = true,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
    TauntAnnounce = true,
    
  },
 
  [62124] = {
--  Paladin
--  Reckoning
    SpellID = "62124",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
    TankCriteria = true,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
    TauntAnnounce = true,
    
  },
  
  [355] = {
--  Warrior
--  Taunt
    SpellID = "355",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
    TankCriteria = true,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
    TauntAnnounce = true,
    
  },

  [185245] = {
--  Demon Hunter
--  Torment
    SpellID = "185245",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
    TankCriteria = true,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
    TauntAnnounce = true,
    
  },
 
  [2649] = {
--  Hunter
--  Pet Growl
    SpellID = "2649",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = use,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
    TauntAnnounce = true,
    
  },  

  [108199] = {
--  Death Knight
--  Gorefiend's Grasp
    SpellID = "108199",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = use,
--  FadeCriteria = ,
--  FadeAnnounce = ,
    TankCriteria = true,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
    TauntAnnounce = true,
    
  },
 
  [49576] = {
--  Death Knight
--  Death Grip
    SpellID = "49576",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = use,
--  FadeCriteria = ,
--  FadeAnnounce = ,
    TankCriteria = true,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
    TauntAnnounce = true,
    
  },

  [57934] = {
--  Rogue
--  Tricks of the Trade
    SpellID = "57934",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = use_on,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
    TauntAnnounce = true,
    
  },
   
  [34477] = {
--  Hunter
--  Misdirection
    SpellID = "34477",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = use_on,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
    TauntAnnounce = true,
    
  },

-- END TAUNTS AND THREAT

-- TANK COOLDOWNS

   [48707] = {
--  Death Knight
--  Anti Magic Shell
    SpellID = "48707",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,   
	
  },

 [81256] = {
--  Death Knight
--  Dancing Rune Weapon
    SpellID = "81256",
    CastCriteria = "SPELL_AURA_APPLIED",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,  
    
  },

 [55233] = {
--  Death Knight
--  Vampiric Blood
    SpellID = "55233",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,  
    
  },

 [206977] = {
--  Death Knight
--  Blood Mirror
    SpellID = "206977",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
    SpamCriteria = true,
--  TauntAnnounce = ,  

    
  },
  
 [116888] = {
--  Death Knight
--  Shroud of Purgatory
    SpellID = "116888",
    CastCriteria = "SPELL_AURA_APPLIED",
    CastAnnounce = cast,
--  FadeCriteria = "SPELL_AURA_REMOVED",
--  FadeAnnounce = fade,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
    SpamCriteria = true,
--  TauntAnnounce = ,  

    
  },  
  
 [204021] = {
--  Demon Hunter
--  Fiery Brand
    SpellID = "204021",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast_on,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade_from_target,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,   
    
  },  

 [187827] = {
--  Demon Hunter
--  Metamorphosis
    SpellID = "187827",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = "SPELL_AURA_REMOVED",
--  FadeAnnounce = fade,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,   
    
  },

  [22812] = {
--  Druid
--  Barkskin
    SpellID = "22812",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,   
    
  },
 
  [61336] = {
--  Druid
--  Survival Instincts
    SpellID = "61336",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
	TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [120954] = {
--  Monk
--  Fortifying Brew
    SpellID = "120954",
    CastCriteria = "SPELL_AURA_APPLIED",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
    
  },

  [122783] = {
--  Monk
--  Diffuse Magic
    SpellID = "122783",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
    
  },
 
  [122278] = {
--  Monk
--  Dampen Harm
    SpellID = "122278",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [115176] = {
--  Monk
--  Zen Meditation
    SpellID = "115176",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,,
    
  },

   [31850] = {
--  Paladin
--  Ardent Defender
    SpellID = "31850",
    CastCriteria = "SPELL_AURA_APPLIED",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [86659] = {
--  Paladin
--  Guardian of Ancient Kings
    SpellID = "86659",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [12975] = {
--  Warrior
--  Last Stand
    SpellID = "12975",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
  
  },
 
  [871] = {
--  Warrior
--  Shield Wall
    SpellID = "871",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [1160] = {
--  Warrior
--  Demoralizing Shout
    SpellID = "1160",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

-- END TANK COOLDOWNS

-- HEALER COOLDOWNS

    [33891] = {
--  Druid
--  Tree of Life
    SpellID = "33891",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [31842] = {
--  Paladin
--  Avenging Wrath
    SpellID = "31842",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [105809] = {
--  Paladin
--  Holy Avenger
    SpellID = "105809",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [200183] = {
--  Priest
--  Apotheosis
    SpellID = "200183",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [197908] = {
--  Monk
--  Mana Tea
    SpellID = "197908",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [114052] = {
--  Shaman
--  Ascendance
    SpellID = "114052",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [108281] = {
--  Shaman
--  Ancestral Guidance
    SpellID = "108281",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [108280] = {
--  Shaman
--  Healing Tide Totem
    SpellID = "108280",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [31821] = {
--  Paladin
--  Aura Mastery
    SpellID = "31821",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
    SpamCriteria = true,
--  TauntAnnounce = ,
    
  },
 
  [740] = {
--  Druid
--  Tranquility
    SpellID = "740",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [64843] = {
--  Priest
--  Divine Hymn
    SpellID = "64843",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
  
  [47536] = {
--  Priest
--  Rapture
    SpellID = "47536",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [64901] = {
--  Priest
--  Symbol of Hope
    SpellID = "64901",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [115310] = {
--  Monk
--  Revival
    SpellID = "115310",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  }, 

  [198664] = {
--  Monk
--  Invoke ChiJi
    SpellID = "198664",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  }, 

-- END HEALER COOLDOWNS

-- HEALER SINGLE TARGET COOLDOWNS

  [102342] = {
--  Druid
--  Ironbark
    SpellID = "102342",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast_on,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade_from_target,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },    
  
    [116849] = {
--  Monk
--  Life Cocoon
    SpellID = "116849",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast_on,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade_from_target,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
  
    [6940] = {
--  Paladin
--  Blessing of Sacrifice
    SpellID = "6940",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast_on,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade_from_target,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,

  },

  [47788] = {
--  Priest
--  Guardian Spirit
    SpellID = "47788",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast_on,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade_from_target,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  }, 

  [33206] = {
--  Priest
--  Pain Suppression
    SpellID = "33206",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast_on,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade_from_target,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
  
  -- END HEALER SINGLE TARGET COOLDOWNS
  
  -- SINGLE TARGET COOLDOWNS
  
     [207810] = {
--  Demon Hunter
--  Nether Bond
    SpellID = "207810",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast_on,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade_from_target,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  }, 
  
    [29166] = {
--  Druid
--  Innervate
    SpellID = "29166",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast_on,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade_from_target,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
  
  [633] = {
--  Paladin
--  Lay on Hands
    SpellID = "633",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast_on,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,,
    
  },
    
  [1022] = {
--  Paladin
--  Blessing of Protection
    SpellID = "1022",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast_on,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade_from_target,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [204018] = {
--  Paladin
--  Blessing of Spellwarding
    SpellID = "204018",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast_on,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade_from_target,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
  
-- END SINGLE TARGET COOLDOWNS

-- RAID COOLDOWNS

   [77761] = {
--  Druid
--  Stampeding Roar
    SpellID = "77761",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
    SpamCriteria = true,
--  TauntAnnounce = ,
    
  },

  [196718] = {
--  Demon Hunter
--  Darkness
    SpellID = "196718",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
    SpamCriteria = true,
--  TauntAnnounce = ,
    
  },

  [204150] = {
--  Paladin
--  Aegis of Light
    SpellID = "204150",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [62618] = {
--  Priest
--  Power Word: Barrier
    SpellID = "62618",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
    SpamCriteria = true,
--  TauntAnnounce = ,
    
  },

  [98008] = {
--  Shaman
--  Spirit Link Totem
    SpellID = "98008",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
    SpamCriteria = true,
--  TauntAnnounce = ,
    
  },

  [192077] = {
--  Shaman
--  Wind Rush Totem
    SpellID = "192077",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
    SpamCriteria = true,
--  TauntAnnounce = ,
    
  },

  [198838] = {
--  Shaman
--  Earthen Shield Totem (Success)
    SpellID = "198838",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
  
  [198839] = {
--  Shaman
--  Earthen Shield Totem (Removed)
    SpellID = "198839",
--  CastCriteria = ,
--  CastAnnounce = ,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  HealerCriteria= ,
--  SpamCriteria = ,
	
  },

  [97462] = {
--  Warrior
--  Commanding Shout (Success)
    SpellID = "97462",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
    SpamCriteria = true,
--  TauntAnnounce = ,
    
  },
 
  [97463] = {
--  Warrior
--  Commanding Shout (Removed)
    SpellID = "97463",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = fade,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
    SpamCriteria = true,
--  TauntAnnounce = ,
    
  },

-- END RAID COOLDOWNS

-- SATED

    [90355] = {
--  Hunter
--  Ancient Hysteria
    SpellID = "90355",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [160452] = {
--  Hunter
--  Netherwinds
    SpellID = "160452",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [80353] = {
--  Mage
--  Time Warp
    SpellID = "80353",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [2825] = {
--  Shaman
--  Bloodlust
    SpellID = "2825",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [32182] = {
--  Shaman
--  Heroism
    SpellID = "32182",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [178208] = {
--  Item
--  Drums of Fury
    SpellID = "178208",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = beat,
--  FadeCriteria = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
  
-- COMBAT RESSES

   [61999] = {
--  Death Knight
--  Raise Ally
    SpellID = "61999",
    CastCriteria = "SPELL_RESURRECT",
    CastAnnounce = cast_on,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  }, 

  [20484] = {
--  Druid
--  Rebirth
    SpellID = "20484",
    CastCriteria = "SPELL_RESURRECT",
    CastAnnounce = cast_on,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
  
  [20702] = {
--  Warlock
--  Soulstone Ressurection
    SpellID = "20707",
    CastCriteria = "SPELL_RESURRECT",
    CastAnnounce = cast_on,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
  
  [225080] = {
--  Shaman
--  Reincarnation - buff for available
    SpellID = "225080",
    CastCriteria = "SPELL_AURA_APPLIED",
    CastAnnounce = ankh_avail,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
   

  [21169] = {
--  Shaman
--  Reincarnation - cast to rez
    SpellID = "21169",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = ankh_used,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [126393] = {
--  Hunter
--  Eternal Guardian
    SpellID = "126393",
    CastCriteria = "SPELL_RESURRECT",
    CastAnnounce = cast_on,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [159956] = {
--  Hunter
--  Dust of Life
    SpellID = "159956",
    CastCriteria = "SPELL_RESURRECT",
    CastAnnounce = cast_on,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [159931] = {
--  Hunter
--  Gift of ChiJi
    SpellID = "159931",
    CastCriteria = "SPELL_RESURRECT",
    CastAnnounce = cast_on,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
   [207399] = {
--  Shaman
--  Ancestrial Protection Totem
    SpellID = "207399",
    CastCriteria = "SPELL_RESURRECT",
    CastAnnounce = cast_on,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

-- END SATED

-- SURRENDER TO MADNESS AND SHROUD

    [193223] = {
--  Priest
--  Surrender to Madness
    SpellID = "193223",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = decides_to,
    FadeCriteria = "SPELL_AURA_REMOVED",
    FadeAnnounce = dies_horribly,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
   
  },

  
    [116888] = {
--  Death Knight
--  Shroud of Purgatory
    SpellID = "116888",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = 
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
   
  },
-- END SURRENDER TO MADNESS AND SHROUD

-- ARTIFACTS

  [203524] = {
--  Warrior
--  Artifact - Neltharion's Fury
    SpellID = "203524",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = harness,
--  FadeCriteria = ,
--  FadeAnnounce = ,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
  
  },

  [200851] = {
--  Druid
--  Artifact - Rage of the Sleeper
    SpellID = "200851",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = harness,
--  FadeCriteria = ,
--  FadeAnnounce = ,
    TankCriteria = true,
    TankAnnounce = true,		
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
  
  },

  [214326] = {
--  Monk
--  Artifact - Exploding Keg
    SpellID = "214326",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = harness,
--  FadeCriteria = ,
--  FadeAnnounce = ,
    TankCriteria = true,
    TankAnnounce = true,		
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
  
  },

  [209202] = {
--  Paladin
--  Artifact - Eye of Tyr
    SpellID = "209202",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = harness,
--  FadeCriteria = ,
--  FadeAnnounce = ,
    TankCriteria = true,
    TankAnnounce = true,		
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
  
  },

  [207778] = {
--  Shaman
--  Artifact - Gift of the Queen
    SpellID = "207778",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = harness,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
  
  },

  [200652] = {
--  Paladin
--  Artifact - Tyr's Deliverance
    SpellID = "200652",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = harness,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
  
  },

  [208253] = {
--  Druid
--  Artifact - Essense of G'Hanir
    SpellID = "208253",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = harness,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
  
  },
  
-- END ARTIFACTS

-- LEGENDARY RINGS

    [187613] = {
--  Item
--  Sanctus, Sigil of the Unbroken
    SpellID = "187613",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = awaken,
--  FadeCriteria = ,
--  FadeAnnounce = ,
    TankCriteria = true,
    TankAnnounce = true,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },  
  
  
  [187612] = {
--  Item
--  Etheralus, the Eternal Reward
    SpellID = "187612",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = awaken,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
    HealerCriteria = true,
    HealerAnnounce = true,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

    [187615] = {
--  Item
--  Maalus, the Blood Drinker
    SpellID = "187615",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = awaken,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,

  },

  [187611] = {
--  Item
--  Nithramus, the All-Seer
    SpellID = "187611",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = awaken,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [187614] = {
--  Item
--  Thorasus, the Stone Heart of Draenor
    SpellID = "187614",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = awaken,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

-- END LEGENDARY RINGS

--  IN COMBAT MANA

   [156436] = {
--  Item
--  Draenic Mana Potion
    SpellID = "156436",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = drink,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [156432] = {
--  Item
--  Draenic Channeled Mana Potion
    SpellID = "156432",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = drink,
    FadeCriteria = "SPELL_AURA_REMOVED",
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [188303] = {
--  Item
--  Ancient Mana Potion
    SpellID = "188303",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = drink_an,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [188336] = {
--  Item
--  Leytorrent Potion
    SpellID = "188336",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = drink,
    FadeCriteria = "SPELL_AURA_REMOVED",
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

 -- END IN COMBAT MANA
 
-- OUT OF COMBAT HEALTH AND MANA

  [29893] = {
--  Warlock
--  Create Soulwell
    SpellID = "29893",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  HealerCriteria = ,
    
  },

  [190336] = {
--  Mage
--  Conjure Refreshment
    SpellID = "190336",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = cast,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

    [111458] = {
--  Item
--  Feast of the Waters
    SpellID = "111458",
    CastCriteria = "SPELL_CAST_START",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [111457] = {
--  Item
--  Feast of Blood
    SpellID = "111457",
    CastCriteria = "SPELL_CAST_START",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [118576] = {
--  Item
--  Savage Feast
    SpellID = "118576",
    CastCriteria = "SPELL_CAST_START",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

-- END OUT OF COMBAT HEALTH AND MANA
 
-- OUT OF COMBAT ITEMS

  [22700] = {
--  Item
--  Field Repair Bot 74A
    SpellID = "22700",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [44389] = {
--  Item
--  Field Repair Bot 110G
    SpellID = "44389",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [67826] = {
--  Item
--  Jeeves
    SpellID = "67826",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [54710] = {
--  Item
--  MOLL-E
    SpellID = "54710",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [54711] = {
--  Item
--  Scrapbot
    SpellID = "54711",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [87214] = {
--  Item
--  Blingtron 4000
    SpellID = "87214",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [111821] = {
--  Item
--  Blingtron 5000
    SpellID = "111821",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [109644] = {
--  Item
--  Walter
    SpellID = "109644",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [132523] = {
--  Item
--  Reaves Battery
    SpellID = "132523",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [132514] = {
--  Item
--  Auto Hammer
    SpellID = "132514",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = place_an,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

-- END OUT OF COMBAT ITEMS

-- OUT OF COMBAT CONSUMABLES
 
  [133579] = {
--  Item
--  Lavish Suramar Feast
    SpellID = "133579",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [133578] = {
--  Item
--  Hearty Feast
    SpellID = "133578",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [127851] = {
--  Item
--  Spirit Cauldron
    SpellID = "127851",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = place,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

-- END OUT OF COMBAT CONSUMABLES

-- OUT OF COMBAT PORTALS AND SUMMONS 

  [53142] = {
--  Mage
--  Portal: Dalaran (H/A)
    SpellID = "53142",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [11417] = {
--  Mage
--  Portal: Orgrimmar (H)
    SpellID = "11417",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [11418] = {
--  Mage
--  Portal: Undercity (H)
    SpellID = "11418",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [11420] = {
--  Mage
--  Portal: Thunder Bluff (H)
    SpellID = "11420",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [32267] = {
--  Mage
--  Portal: Silvermoon (H)
    SpellID = "32267",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [35717] = {
--  Mage
--  Portal: Shattrath (H)
    SpellID = "35717",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [49361] = {
--  Mage
--  Portal: Stonard (H)
    SpellID = "49361",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [88346] = {
--  Mage
--  Portal: Tol Barad (H)
    SpellID = "88346",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [132626] = {
--  Mage
--  Portal: Vale of the Eternal Blossoms (H)
    SpellID = "132626",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [176244] = {
--  Mage
--  Portal: Warspear (H)
    SpellID = "176244",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [10059] = {
--  Mage
--  Portal: Stormwind (A)
    SpellID = "10059",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [11416] = {
--  Mage
--  Portal: Ironforge (A)
    SpellID = "11416",
    CastCriteria = "SPELL_CREATE",
--  CastAnnounce = ,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [11419] = {
--  Mage
--  Portal: Darnassus (A)
    SpellID = "11419",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [32266] = {
--  Mage
--  Portal: Exodar (A)
    SpellID = "32266",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [33691] = {
--  Mage
--  Portal: Shattrath (A)
    SpellID = "33691",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [49360] = {
--  Mage
--  Portal: Theramore (A)
    SpellID = "49360",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [88345] = {
--  Mage
--  Portal: Tol Barad (A)
    SpellID = "88345",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [132620] = {
--  Mage
--  Portal: Vale of the Eternal Blossoms (A)
    SpellID = "132620",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
 
  [176246] = {
--  Mage
--  Portal: Stormshield (A)
    SpellID = "176246",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
  
  [224871] = {
--  Mage
--  Portal: Dalaran - Broken Isles (A/H)
    SpellID = "224871",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_a,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },

  [120146] = {
--  Mage
--  Ancient Portal: Dalaran (A/H)
    SpellID = "120146",
    CastCriteria = "SPELL_CREATE",
    CastAnnounce = create_an,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },


  [698] = {
--  Warlock
--  Ritual of Summoning
    SpellID = "698",
    CastCriteria = "SPELL_CAST_SUCCESS",
    CastAnnounce = begin,
--  FadeCriteria = ,
--  FadeAnnounce = ,
--  TankCriteria = ,
--  TankAnnounce = ,	
--  HealerCriteria = ,
--  HealerAnnounce = ,
--  SpamCriteria = ,
--  TauntAnnounce = ,
    
  },
  
--  END OUT OF COMBAT PORTALS AND SUMMONS 
}
 
 
 
 
 
local function printf(s,...)
  print("|cff39d7e5CDSpy:|r " .. s:format(...))
end

CDSpy:SetScript("OnEvent", function(self, event, ...)
  self[event](self, ...)
end)

local function send(message)
  if instance == "raid" and not IsInGroup(LE_PARTY_CATEGORY_INSTANCE) and (CDSpyDB.raid_toggle or CDSpyDB.override) then
    SendChatMessage(message, CDSpyDB.raid_output, nil, CDSpyDB.raid_channel_id)
  elseif instance == "party" and not IsInGroup(LE_PARTY_CATEGORY_INSTANCE) and (CDSpyDB.party_toggle or CDSpyDB.override) then
    SendChatMessage(message, CDSpyDB.party_output, nil, CDSpyDB.party_channel_id)
  elseif (select(3,GetInstanceInfo())==17 or IsLFGModeActive(LE_LFG_CATEGORY_LFD)) and (CDSpyDB.pug_toggle or CDSpyDB.override) then
    SendChatMessage(message, CDSpyDB.pug_output, nil, CDSpyDB.pug_channel_id)
  elseif CDSpyDB.override then
    SendChatMessage(message, CDSpyDB.raid_output, nil, CDSpyDB.raid_channel_id)
  end
  
  if CDSpyDB.debug_toggle then
    print(message)
  end
  
end
 

local function is_tank(name)
  return GetPartyAssignment("MAINTANK", name, 1) or UnitGroupRolesAssigned(name) == "TANK"
end

local function is_healer(name)
  return UnitGroupRolesAssigned(name) == "HEALER"
end
 
function CDSpy:COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, hideCaster, srcGUID, srcName, srcFlags, srcRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, school, ...)
 
  if not UnitExists(srcName) then return end -- If the source isn't in the raid/party
  
  if not CDSpyDB.enable_toggle then return end -- If Global Announce is off
 
  -- if UnitAffectingCombat(srcName) then -- If the caster is in combat
  
    if SpellArray[spellID] then
    
      if event == SpellArray[spellID]["CastCriteria"] then
      
        if CDSpyDB.taunt_toggle == false and SpellArray[spellID]["TauntCriteria"] then return end
        
        if CDSpyDB.tank_toggle == false and SpellArray[spellID]["TankAnnounce"] then return end
        
        if CDSpyDB.healer_toggle == false and SpellArray[spellID]["HealerAnnounce"] then return end
      
        if SpellArray[spellID]["TankCriteria"] then
        
          --  if is_tank(srcName) == SpellArray[spellID]["TankCriteria"] then
            
            send(SpellArray[spellID]["CastAnnounce"]:format(srcName, GetSpellLink(spellID), destName))
              
          --  end
            
        elseif SpellArray[spellID]["HealerCriteria"] then
        
          --  if is_healer(srcName) == SpellArray[spellID]["HealerCriteria"] then

            send(SpellArray[spellID]["CastAnnounce"]:format(srcName, GetSpellLink(spellID), destName))
          
          -- end
        
        else
        
          send(SpellArray[spellID]["CastAnnounce"]:format(srcName, GetSpellLink(spellID), destName))
        
        end
        
      end
      
      
      
      
      if event == SpellArray[spellID]["FadeCriteria"] then
      
        if SpellArray[spellID]["SpamCriteria"] and srcName ~= destName then return end -- Block spammy things
        
        if CDSpyDB.tank_toggle == false and SpellArray[spellID]["TankAnnounce"] then return end
        
        if CDSpyDB.healer_toggle == false and SpellArray[spellID]["HealerAnnounce"] then return end        
      
        if SpellArray[spellID]["TankCriteria"] then
            
         -- if is_tank(srcName) == SpellArray[spellID]["TankCriteria"] then

            send(SpellArray[spellID]["FadeAnnounce"]:format(srcName, GetSpellLink(spellID), destName))
              
         -- end
            
        elseif SpellArray[spellID]["HealerCriteria"] then
            
          --  if is_healer(srcName) == SpellArray[spellID]["HealerCriteria"] then

            send(SpellArray[spellID]["FadeAnnounce"]:format(srcName, GetSpellLink(spellID), destName))
              
         -- end
            
        else
            
          send(SpellArray[spellID]["FadeAnnounce"]:format(srcName, GetSpellLink(spellID), destName))
            
        end
        
      end
        
    end
    
  -- end
  
end



function CDSpy:PLAYER_REGEN_DISABLED()
  wipe(reincarnations)
  self:UnregisterEvent("UNIT_HEALTH")
end



function CDSpy:CheckEnable(isEnteringWorld)
  _, instance = IsInInstance()
  
  if CDSpyDB.enable_toggle and (instance == "raid" or instance == "party") then
    self:RegisterEvents()
  elseif CDSpyDB.override then
    self:RegisterEvents()
  else
   self:UnregisterEvents()
  end
  
end

function CDSpy:PLAYER_ENTERING_WORLD()
	self:CheckEnable(true)
end

function CDSpy:RegisterEvents()
  self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
  self:RegisterEvent("PLAYER_REGEN_DISABLED")
  print("CDSpy is ONLINE in this zone")
  raid_channel_id = GetChannelName(CDSpyDB.raid_channel_id)
  party_channel_id = GetChannelName(CDSpyDB.party_channel_id)
  pug_channel_id = GetChannelName(CDSpyDB.pug_channel_id)
end

function CDSpy:UnregisterEvents()
  self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
  self:UnregisterEvent("PLAYER_REGEN_DISABLED")
  self:UnregisterEvent("UNIT_HEALTH")
  print("CDSpy is OFFLINE in this zone")
  wipe(reincarnations)
end

function CDSpy:CreateSlashCommands()

	SLASH_CDSPY1 = "/cdspy"
	SlashCmdList.CDSPY = function(msg)
    InterfaceOptionsFrame_OpenToCategory("CDSpy")
    InterfaceOptionsFrame_OpenToCategory("CDSpy")
  end
	
end

function CDSpy:ADDON_LOADED(loadedAddon)

  if loadedAddon ~= "CDSpy" then return end
  
  local defaults = {
    override = true,
    enable_toggle = true,
    debug_toggle = true,
    taunt_toggle = true,
    tank_toggle = true,
    healer_toggle = true,
    party = true,
    fade = true,
    tricks = true,
    manacd = true,
    mana = 80000,
    raid_output = "RAID",
    raid_channel_id = "5",
    raid_channel_name = "CDSpyReports",
    raid_toggle = true,
    party_output = "PARTY",    
    party_channel_id = "5",
    party_channel_name = "CDSpyReports",
    party_toggle = true,
    pug_output = "INSTANCE_CHAT",    
    pug_channel_id = "5",
    pug_channel_name = "CDSpyReports",
    pug_toggle = false,
  }
  
  CDSpyDB = CDSpyDB or {}
  for k,v in pairs(defaults) do
    if CDSpyDB[k] == nil then
      CDSpyDB[k] = v
    end
  end
  
  self.db = CDSpyDB
  addon.db = CDSpyDB
 
  self:CreateSlashCommands()
  self:CheckEnable()
  self:RegisterEvent("PLAYER_ENTERING_WORLD")
  
end


CDSpy:RegisterEvent("ADDON_LOADED")
